//---------------------------------------------------------------------------
#ifndef TestMainH
#define TestMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>

#include <Winsock.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TMainMenu *MainMenu1;
    TPopupMenu *PopupMenu;
    TListView *MailListView;
    TSplitter *Splitter1;
    TMemo *BodyMemo;
    TMenuItem *File1;
    TMenuItem *O1;
    TMenuItem *mCreate;
    TMenuItem *mReply;
    TMenuItem *N1;
    TMenuItem *mRenewal;
    TMenuItem *N2;
    TMenuItem *mDelete;
    TMenuItem *N3;
    TMenuItem *mExit;
    TMenuItem *mPopupReply;
    TMenuItem *N4;
    TMenuItem *mPopupDelete;
    TMenuItem *mSetting;
    TMenuItem *mSave;
    TMenuItem *N5;
    TMenuItem *mAttachment;
    TSaveDialog *SaveDialog;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall mCreateClick(TObject *Sender);
    void __fastcall mRenewalClick(TObject *Sender);
    void __fastcall mExitClick(TObject *Sender);
    void __fastcall mSettingClick(TObject *Sender);
    void __fastcall mPopupReplyClick(TObject *Sender);
    void __fastcall mPopupDeleteClick(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall MailListViewMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall MailListViewClick(TObject *Sender);
    void __fastcall mSaveClick(TObject *Sender);
    
    void __fastcall mAttachmentClick(TObject *Sender);
private:	// [U[錾
    SOCKET S;               // \Pbg
    AnsiString Id;          // ID
    AnsiString Password;    // pX[h
    AnsiString Pop3Name;    // POP3T[o[
    Boolean APopFlag;       // APOP gp邩
    void AddMailList(SOCKET S); // 薼ꗗ ListView ɕ\
    void HeaderDataClear(void);
public:		// [U[錾
    __fastcall TMainForm(TComponent* Owner);
    AnsiString SmtpName;    // SMTPT[o[
    AnsiString MailAddress; // [AhX
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#define OPTION_SECTION          "BCBMAIL"
#define OPTION_APOP_FLAG        "ApopFlag"
#define OPTION_SMTP_NAME        "SmtpName"
#define OPTION_POP3_NAME        "Pop3Name"
#define OPTION_MAIL_ADDRESS     "MailAddress"

#define HEADER_MAX              8192

#endif
