Imports System
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Net.Sockets
Imports System.IO
Imports System.Runtime.Serialization

Namespace nMail

	''' <summary>
	''' nMail.DLL G[ԂĂꍇɔO
	''' </summary>
    Class nMailException
        Inherits ApplicationException

        Private _error_code As Integer

		''' <summary>
		''' G[bZ[WƃG[R[hw肵āA<c>nMailException</c>NX̐VCX^X܂B
		''' </summary>
		''' <param name="message"></param>
		''' <param name="error_code"></param>
        Public Sub New(ByVal message As String, ByVal error_code As Integer)
            MyBase.New(message)
            _error_code = error_code
        End Sub

		''' <summary>
		''' G[R[hłB
		''' </summary>
        Public ReadOnly Property ErrorCode() As Integer
            Get
                Return _error_code
            End Get
        End Property

		''' <summary>
		''' T[o[ԂꂽG[bZ[WłB
		''' </summary>
        Public Overrides ReadOnly Property Message() As String
            Get
                Return MyBase.Message
            End Get
        End Property

    End Class

	''' <summary>
	''' Winsock ֘ANX
	''' </summary>
    Class Winsock

		''' <summary>
		''' Winsock ܂B
		''' </summary>
        <DllImport("nMail.DLL", EntryPoint:="NMailInitializeWinSock")> _
        Public Shared Function Initialize() As Boolean
        End Function

		''' <summary>
		''' Winsock ̎gpI܂B
		''' </summary>
        <DllImport("nMail.DLL", EntryPoint:="NMailEndWinSock")> _
        Public Shared Function Done() As Boolean
        End Function

    End Class

	''' <summary>
	''' POP3[MNX
	''' </summary>
    Class Pop3
        Implements IDisposable

		''' <summary>
		''' wb_̈̃TCYłB
		''' </summary>
        Protected Const HeaderSize As Integer = 32768
		''' <summary>
		''' pX̃TCYłB
		''' </summary>
        Protected Const MaxPath As Integer = 32768
		''' <summary>
		''' g@\pobt@TCYłB
		''' </summary>
        Protected Const AttachmentTempSize As Integer = 400

		''' <summary>
		''' \PbgG[͖ڑԂłB
		''' </summary>
		''' <remarks>
		''' <para><see cref="Connect"/>Ăяo<see cref="GetMail"/>A</para>
		''' <para>ĂяoAȂ炩̗RŐڑؒfƂ̃G[ƂȂ܂B</para>
		''' <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		''' </remarks>
        Public Const ErrorSocket As Integer = -1
		''' <summary>
		''' F؃G[łB
		''' </summary>
		''' <remarks>
		''' <para><see cref="Authenticate"/>ĂяoŔF؂Ɏsꍇ</para>
		''' <para>̃G[ƂȂ܂B</para>
		''' <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		''' </remarks>
        Public Const ErrorAuthenticate As Integer = -2
		''' <summary>
		''' ԍŎw肳ꂽ[݂܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="GetMail"/>Ŏw肵ԍ̃[݂ȂƂ̃G[ƂȂ܂B</para>
		''' <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		''' </remarks>
        Public Const ErrorInvalidNo As Integer = -3
		''' <summary>
		''' ^CAEgG[łB
		''' </summary>
		''' <remarks>
		''' <para><see cref="Options.Timeout"/>Ŏw肵l蒷ԃT[o牞</para>
		''' <para>ȂꍇÃG[܂B</para>
		''' <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		''' </remarks>
        Public Const ErrorTimeout As Integer = -4
		''' <summary>
		''' Ytt@CJ܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="Path"/>Ŏw肵tH_ɓYtt@C߂Ȃ</para>
		''' <para>ȂꍇÃG[܂B</para>
		''' <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		''' </remarks>
        Public Const ErrorFileOpen As Integer = -5
		''' <summary>
		''' t@CĂ܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="Flag"/><see cref="PartialAttachmentFile"/> ݒ肵</para>
		''' <para><see cref="GetMail"/>ĂяoۂɁAT[oɕꂽ[ׂ</para>
		''' <para>ĂȂꍇɂ̃G[܂B</para>
		''' <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		''' </remarks>
        Public Const ErrorPartial As Integer = -6
		''' <summary>
		''' Ytt@CƓ̃t@CtH_ɑ݂܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="nMail.Options.AlreadyFile"/>  <see cref="nMail.Options.FileAlreadyError"/></para>
		''' <para>ݒ肵A<see cref="Path"/>Ŏw肵tH_ɓYtt@CƓÕt@C</para>
		''' <para>ꍇɂ̃G[܂B</para>
		''' <para><see cref="nMailException.ErrorCode"/>ɐݒ肳܂B</para>
		''' </remarks>
        Public Const ErrorFileAlready As Integer = -7
		''' <summary>
		''' mۃG[łB
		''' </summary>
		''' <remarks>
		''' ŕR[hϊ邽߂̃mۂł܂łB
		''' </remarks>
        Public Const ErrorMemory As Integer = -9
		''' <summary>
		''' ̑̃G[łB
		''' </summary>
        Public Const ErrorEtc As Integer = -10
		''' <summary>
		''' Ytt@CMł܂c肪ԂłB
		''' </summary>
		''' <remarks>
		''' <para><see cref="Flag"/><see cref="SuspendAttachmentFile"/>܂</para>
		''' <para><see cref="SuspendNext"/>w肵<see cref="GetMail"/></para>
		''' <para>ĂяoꍇA܂[̎c肪ꍇA<see cref="nMailException.ErrorCode"/></para>
		''' <para>ɐݒ肳܂B</para>
		''' </remarks>
        Public Const ErrorSuspEndAttachmentFile As Integer = -20
		''' <summary>
		''' Ytt@C݂͑܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="GetAttachmentFileStatus"/> sAYtt@C݂Ȃꍇ</para>
		''' <para><see cref="PartNo"/> ɐݒ肳܂B</para>
		''' </remarks>
        Public Const NoAttachmentFile As Integer = -1
		''' <summary>
		''' Ytt@C݂͑܂AĂ܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="GetAttachmentFileStatus"/> sAYtt@C݂Ȃꍇ</para>
		''' <para><see cref="PartNo"/> ɐݒ肳܂B</para>
		''' </remarks>
        Public Const AttachmentFile As Integer = 0
		''' <summary>
		''' s
		''' </summary>
		''' <para>e탁\bhԂꍇA<see cref="nMailException.ErrorCode"/>ɐݒ肳lłB</para>
        Public Const Success As Integer = 0
		''' <summary>
		''' ꂽYtt@C擾܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="GetMail"/>̑OɁA<see cref="Flag"/>ɐݒ肵Ă܂B</para>
		''' </remarks>
        Public Const PartialAttachmentFile As Integer = 1
		''' <summary>
		''' [{̂ݎ擾܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="GetMail"/>̑OɁA<see cref="Flag"/>ɐݒ肵Ă܂B</para>
		''' </remarks>
        Public Const TextOnly As Integer = 2
		''' <summary>
		''' Ytt@CMňꎞx~̈ڂɎw肵܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="GetMail"/>̑OɁA<see cref="Flag"/>ɐݒ肵Ă܂B</para>
		''' </remarks>
        Public Const SuspendAttachmentFile As Integer = 4
		''' <summary>
		''' Ytt@CMňꎞx~̓ڈȍ~Ɏw肵܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="GetMail"/>̑OɁA<see cref="Flag"/>ɐݒ肵Ă܂B</para>
		''' </remarks>
        Public Const SuspendNext As Integer = 8
		''' <summary>
		''' UIDL ׂĎ擾܂B
		''' </summary>
		''' <remarks>
		''' <see cref="GetUidl"/>Ŏw肷邱ƂɂđSĂ UIDL 擾ł܂B
		''' </remarks>
        Public Const UidlAll As Integer = 0

		''' <summary>
		''' POP3 |[gԍłB
		''' </summary>
        Protected _port As Integer = 110
		''' <summary>
		''' \PbgnhłB
		''' </summary>
        Protected _socket As Integer = ErrorSocket
		''' <summary>
		''' [łB
		''' </summary>
        Protected _count As Integer = -1
		''' <summary>
		''' [TCYłB
		''' </summary>
        Protected _size As Integer = -1
		''' <summary>
		''' wb_[TCYłB
		''' </summary>
        Protected _header_size As Integer = -1
		''' <summary>
		''' {̃TCYłB
		''' </summary>
        Protected _body_size As Integer = -1
		''' <summary>
		''' [M̐ݒptOłB
		''' </summary>
        Protected _flag As Integer = 0
		''' <summary>
		''' t@CԍłB
		''' </summary>
        Protected _part_no As Integer = -1
		''' <summary>
		''' G[ԍłB
		''' </summary>
        Protected _err As Integer
		''' <summary>
		''' APOP gp邩ǂ̃tOłB
		''' </summary>
        Protected _apop As Boolean = false
		''' <summary>
		''' POP3 T[ołB
		''' </summary>
        Protected _host As String = ""
		''' <summary>
		''' POP3 [U[łB
		''' </summary>
        Protected _id As String = ""
		''' <summary>
		''' POP3 pX[hłB
		''' </summary>
        Protected _password As String = ""
		''' <summary>
		''' Ytt@Cۑp̃pXłB
		''' </summary>
        Protected _path As String = ""
		''' <summary>
		''' wb_tB[hłB
		''' </summary>
        Protected _field_name As String = ""
		''' <summary>
		''' {i[obt@łB
		''' </summary>
        Protected _body As StringBuilder
		''' <summary>
		''' i[obt@łB
		''' </summary>
        Protected _subject As StringBuilder
		''' <summary>
		''' tۑobt@łB
		''' </summary>
        Protected _date As StringBuilder
		''' <summary>
		''' oli[obt@łB
		''' </summary>
        Protected _from As StringBuilder
		''' <summary>
		''' wb_i[obt@łB
		''' </summary>
        Protected _header As StringBuilder
		''' <summary>
		''' Ytt@Ci[obt@łB
		''' </summary>
        Protected _filename As StringBuilder
		''' <summary>
		''' Ytt@C̃XgłB
		''' </summary>
        Protected _filename_list As String() = nothing
		''' <summary>
		''' wb_tB[hei[obt@łB
		''' </summary>
        Protected _field As StringBuilder
		''' <summary>
		''' t@C ID łB
		''' </summary>
        Protected _part_id As StringBuilder
		''' <summary>
		''' UIDL i[obt@łB
		''' </summary>
        Protected _uidl As StringBuilder
		''' <summary>
		''' g@\pobt@łB
		''' </summary>
        Protected _temp() As Byte
		''' <summary>
		''' Dispose sǂ̃tOłB
		''' </summary>
        Protected _disposed As Boolean = false

		''' <summary>
		''' <c>Pop3</c>NX̐VKCX^X܂B
		''' </summary>
        Public Sub New()
            Init()
        End Sub

		''' <summary>
		''' <c>Pop3</c>NX̐VKCX^X܂B
		''' <param name="host_name">POP3 T[o[</param>
		''' </summary>
        Public Sub New(ByVal host As String)
            Init()
            _host = host
        End Sub

        Protected Overrides Sub Finalize()
            MyBase.Finalize()
            Dispose(False)
        End Sub

		''' <summary>
		''' <see cref="Pop3"/>ɂĎgpĂ邷ׂẴ\[X܂B
		''' </summary>
        Overridable Overloads Sub Dispose() Implements IDisposable.Dispose
            Dispose(True)
            GC.SuppressFinalize(Me)
        End Sub

		''' <summary>
		''' <see cref="Pop3"/>ɂĎgpĂ邷ׂẴ\[X܂B
		''' </summary>
		''' <param name="disposing">
		''' }l[W\[XƃA}l[W\[X̗ꍇ<c>true</c>B
		''' A}l[W\[Xꍇ<c>false</c>B
		''' </param>
        Protected Overloads Sub Dispose(ByVal disposing As Boolean)
            If Not _disposed Then
                If disposing Then
                End If
                If _socket <> ErrorSocket Then
                    Pop3Close(_socket)
                    _socket = ErrorSocket
                End If
                _disposed = True
            End If
        End Sub

		''' <summary>
		''' łB
		''' </summary>
        Protected Sub Init()
            _temp = New Byte(AttachmentTempSize) {}
        End Sub

        <DllImport("nMail.DLL", EntryPoint:="NMailPop3ConnectPortNo", CharSet:=CharSet.Auto)> _
        Protected Shared Function Pop3ConnectPortNo(ByVal Host As String, ByVal Port As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailPop3Close")> _
        Protected Shared Function Pop3Close(ByVal Socket As Integer) As Boolean
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailPop3Authenticate", CharSet:=CharSet.Auto)> _
        Protected Shared Function Pop3Authenticate(ByVal Socket As Integer, ByVal Id As String, ByVal Pass As String, ByVal APopFlag As Boolean) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailPop3GetMailStatus", CharSet:=CharSet.Auto)> _
        Protected Shared Function Pop3GetMailStatus(ByVal Socket As Integer, ByVal No As Integer, ByVal Subject As StringBuilder, ByVal DateStr As StringBuilder, ByVal From As StringBuilder, ByVal Header As StringBuilder, ByVal SizeFlag As Boolean) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailPop3GetMailSize")> _
        Protected Shared Function Pop3GetMailSize(ByVal Socket As Integer, ByVal No As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailPop3GetMail", CharSet:=CharSet.Auto)> _
        Protected Shared Function Pop3GetMail(ByVal Socket As Integer, ByVal No As Integer, ByVal Subject As StringBuilder, ByVal DateStr As StringBuilder, ByVal From As StringBuilder, ByVal Header As StringBuilder, ByVal Body As StringBuilder, ByVal Path As String, ByVal FileName As StringBuilder) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailPop3GetMailEx", CharSet:=CharSet.Auto)> _
        Protected Shared Function Pop3GetMailEx(ByVal Socket As Integer, ByVal No As Integer, ByVal Subject As StringBuilder, ByVal DateStr As StringBuilder, ByVal From As StringBuilder, ByVal Header As StringBuilder, ByVal Body As StringBuilder, ByVal Path As String, ByVal FileName As StringBuilder, ByVal Temp() As Byte, ByVal Flag As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailPop3DeleteMail")> _
        Protected Shared Function Pop3DeleteMail(ByVal Socket As Integer, ByVal No As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailGetHeaderField", CharSet:=CharSet.Auto)> _
        Protected Shared Function Pop3GetHeaderField(ByVal Field As StringBuilder, ByVal Header As String, ByVal Name As String, ByVal Size As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailPop3GetUidl", CharSet:=CharSet.Auto)> _
        Protected Shared Function Pop3GetUidl(ByVal Socket As Integer, ByVal No As Integer, ByVal Id As StringBuilder, ByVal Max As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailPop3GetAttachmentFileStatus", CharSet:=CharSet.Auto)> _
        Protected Shared Function Pop3GetAttachmentFileStatus(ByVal Socket As Integer, ByVal No As Integer, ByVal Id As StringBuilder, ByVal Max As Integer) As Integer
        End Function

		''' <summary>
		''' wb_i[pobt@̃TCY肵܂B
		''' </summary>
        Protected Sub SetHeaderSize()
            If _header_size < 0 Then
                _header_size = Options.HeaderMax
            End If
            If _header_size <= 0 Then
                _header_size = HeaderSize
                Options.HeaderMax = _header_size
            End If
        End Sub

		''' <summary>
		''' POP3 T[oɐڑ܂B
		''' </summary>
		''' <remarks>
		''' POP3 T[oɐڑ܂B
		''' </remarks>
        Public Sub Connect()
            If (_port < 0) Or (_port > 65536) Then
                Throw New ArgumentOutOfRangeException
            End If
            _socket = Pop3ConnectPortNo(_host, _port)
            If (_socket = ErrorSocket) Or (_socket = ErrorTimeout) Then
                _err = _socket
                _socket = ErrorSocket
                Throw New nMailException("Connect", _err)
            End If
        End Sub

		''' <summary>
		''' POP3 T[oɐڑ܂B
		''' </summary>
		''' <param name="host_name">POP3 T[o[</param>
		''' <remarks>
		''' POP3 T[oɐڑ܂B
		''' </remarks>
        Public Sub Connect(ByVal host_name As String)
            _host = host_name
            Connect()
        End Sub

		''' <summary>
		''' POP3 T[oɐڑ܂B
		''' </summary>
		''' <param name="host_name">POP3 T[o</param>
		''' <param name="port_no">|[gԍ</param>
		''' <remarks>
		''' POP3 T[oɐڑ܂B
		''' </remarks>
        Public Sub Connect(ByVal host_name As String, ByVal port_no As Integer)
            _host = host_name
            _port = port_no
            Connect()
        End Sub

		''' <summary>
		''' POP3 T[oɐڑ܂B
		''' </summary>
		''' <param name="port_no">|[gԍ</param>
		''' <remarks>
		''' POP3 T[oɐڑ܂B
		''' </remarks>
        Public Sub Connect(ByVal port_no As Integer)
            _port = port_no
            Connect()
        End Sub

		''' <summary>
		''' POP3 T[oƂ̐ڑI܂B
		''' </summary>
        Public Sub Close()
            If _socket <> ErrorSocket Then
                Pop3Close(_socket)
            End If
            _socket = ErrorSocket
        End Sub

		''' <summary>
		''' POP3 T[oF؂s܂B
		''' </summary>
		''' <remarks>
		''' POP3 T[oF؂s܂B
		''' </remarks>
		''' <param name="id_str">POP3 [U[ ID</param>
		''' <param name="pass_str">POP3 pX[h</param>
        Public Sub Authenticate(ByVal id_str As String, ByVal pass_str As String)
            If (id_str = "") Or (pass_str = "") Then
                Throw New FormatException
            End If
            If _socket = ErrorSocket Then
                Throw New InvalidOperationException
            End If
            _id = id_str
            _password = pass_str
            _body_size = -1
            _count = Pop3Authenticate(_socket, _id, _password, _apop)
            If _count < 0 Then
                _err = _count
                Throw New nMailException("Authenticate:" + Options.ErrorMessage, _err)
            End If
        End Sub

		''' <summary>
		''' POP3 T[oF؂s܂B
		''' </summary>
		''' <remarks>
		''' POP3 T[oF؂s܂B
		''' </remarks>
		''' <param name="id_str">POP3 [U[ ID</param>
		''' <param name="pass_str">POP3 pX[h</param>
		''' <param name="apop_flag">APOP gp邩</param>
        Public Sub Authenticate(ByVal id_str As String, ByVal pass_str As String, ByVal apop_flag As Boolean)
            _apop = apop_flag
            Authenticate(id_str, pass_str)
        End Sub

		''' <summary>
		''' [̃Xe[^X擾܂B
		''' </summary>
		''' <param name="no">[ԍ</param>
		''' <remarks>
		''' <paramref name="no"/>p[^ŃXe[^X擾[ԍw肵܂B
		''' <para><see cref="Subject"/>Ŏ擾ł܂B</para>
		''' <para>t<see cref="DateString"/>Ŏ擾ł܂B</para>
		''' <para>ol<see cref="From"/>Ŏ擾ł܂B</para>
		''' <para>wb_<see cref="Header"/>Ŏ擾ł܂B</para>
		''' <para>[TCY<see cref="Size"/>Ŏ擾ł܂B</para>
		''' <para>Xe[^X擾s̏ꍇ̃G[ԍ<see cref="nMailException.ErrorCode"/>Ŏ擾ł܂B</para>
		''' </remarks>
        Public Sub GetStatus(ByVal no As Integer)
            If _socket = ErrorSocket Then
                Throw New InvalidOperationException
            End If
            SetHeaderSize()
            _subject = New StringBuilder(_header_size)
            _date = New StringBuilder(_header_size)
            _from = New StringBuilder(_header_size)
            _header = New StringBuilder(_header_size)
            _err = Pop3GetMailStatus(_socket, no, _subject, _date, _from, _header, False)
            If _err < 0 Then
                Throw New nMailException("GetStatus:" + Options.ErrorMessage, _err)
            End If
        End Sub

		''' <summary>
		''' [̃TCY擾܂B
		''' </summary>
		''' <param name="no">[ԍ</param>
		''' <remarks>
		''' <paramref name="no"/>p[^Ń[TCY擾[ԍw肵܂B
		''' </remarks>
		''' <returns>[TCY</returns>
        Public Function GetSize(ByVal no As Integer) As Integer
            If _socket = ErrorSocket Then
                Throw New InvalidOperationException
            End If
            _size = Pop3GetMailSize(_socket, no)
            If _size < 0 Then
                _err = _size
                Throw New nMailException("GetSize:" + Options.ErrorMessage, _err)
            Else
                _body_size = _size * 2
            End If
            Return Size
        End Function

		''' <summary>
		''' [擾܂B
		''' </summary>
		''' <param name="no">[ԍ</param>
		''' <remarks>
		''' <paramref name="no"/>p[^Ń[擾[ԍw肵܂B
		''' <para>Ytt@CWJꍇA<see cref="Path"/>ɓWJtH_w肵Ă܂B</para>
		''' <para>g@\gpꍇA<see cref="Flag"/>Őݒ肵Ă܂B</para>
		''' <para><see cref="Subject"/>Ŏ擾ł܂B</para>
		''' <para>t<see cref="DateString"/>Ŏ擾ł܂B</para>
		''' <para>ol<see cref="From"/>Ŏ擾ł܂B</para>
		''' <para>wb_<see cref="Header"/>Ŏ擾ł܂B</para>
		''' <para>[TCY<see cref="Size"/>Ŏ擾ł܂B</para>
		''' <para>Ytt@C<see cref="FileName"/>Ŏ擾ł܂B</para>
		''' </remarks>
        Public Sub GetMail(ByVal no As Integer)
            If _socket = ErrorSocket Then
                Throw New InvalidOperationException
            End If
            If (_path <> "") And (Not Directory.Exists(_path)) Then
                Throw New DirectoryNotFoundException(_path)
            End If
			if no <= 0 then
				throw new ArgumentOutOfRangeException()
			end if
			if (_flag and SuspendNext) <> 0 then
				_err = Pop3GetMailEx(_socket, no, _subject, _date, _from, _header, _body, _path, _filename, _temp, _flag)
			else
	            SetHeaderSize()
    	        _subject = New StringBuilder(_header_size)
        	    _date = New StringBuilder(_header_size)
            	_from = New StringBuilder(_header_size)
	            _header = New StringBuilder(_header_size)
    	        _filename = New StringBuilder(MaxPath)
        	    If _body_size < 0 Then
	                GetSize(no)
    	        End If
        	    If _body_size > 0 Then
	                _body = New StringBuilder(_body_size)
    	            If Flag <> 0 Then
        	            _err = Pop3GetMailEx(_socket, no, _subject, _date, _from, _header, _body, _path, _filename, _temp, _flag)
            	    Else
	                    _err = Pop3GetMail(_socket, no, _subject, _date, _from, _header, _body, _path, _filename)
    	            End If
				end if
			end if
			if _err <> ErrorSuspendAttachmentFile then
                If _filename.Length > 0 Then
                    _filename_list = _filename.ToString().Split(Options.SplitChar)
                Else
                    _filename_list = nothing
                End If
			end if
            If (_err < 0) And (_err <> ErrorSuspEndAttachmentFile) Then
                Throw New nMailException("GetMail:" + Options.ErrorMessage, _err)
            End If
        End Sub

		''' <summary>
		''' [폜܂B
		''' </summary>
		''' <param name="no">[ԍ</param>
		''' <remarks>
		''' <para>[폜s̏ꍇ̃G[ԍ<see cref="nMailException.ErrorCode"/>Ŏ擾ł܂B</para>
		''' </remarks>
        Public Sub Delete(ByVal no As Integer)
            If _socket = ErrorSocket Then
                Throw New InvalidOperationException
            End If
            _err = Pop3DeleteMail(_socket, no)
            If _err < 0 Then
                Throw New nMailException("Delete:" + Options.ErrorMessage, _err)
            End If
        End Sub

		''' <summary>
		''' Ytt@C̑݃`FbNs܂B
		''' </summary>
		''' <param name="no">[ԍ</param>
		''' <remarks>
		''' <para>Ytt@C̕<see cref="PartNo"/>Ŏ擾ł܂B</para>
		''' <para><see cref="NoAttachmentFile"/>̏ꍇYtt@C͂܂B</para>
		''' <para><see cref="AttachmentFile"/>̏ꍇĂȂYtt@Ct[łB</para>
		''' <para>1 ȏ̏ꍇĂYtt@CŕԂl̓p[gԍ\܂B</para>
		''' <para>1 ̏ꍇ́A<see cref="Flag"/><see cref="PartialAttachmentFile"/> ݒ肵
		''' <see cref="GetMail"/>ĂяoƓYtt@Cĕۑ\łB</para>
		''' </remarks>
        Public Function GetAttachmentFileStatus(ByVal no As Integer) As Boolean
            If _socket = ErrorSocket Then
                Throw New InvalidOperationException
            End If
            SetHeaderSize()
            _part_id = New StringBuilder(_header_size)
            _part_no = Pop3GetAttachmentFileStatus(_socket, no, _part_id, _header_size)
            If _part_no > 0 Then
                Return True
            Else
                Return False
            End If
        End Function

		''' <summary>
		''' [ UIDL 擾܂B
		''' </summary>
		''' <param name="no">[ԍ</param>
		''' <remarks>
		''' <para>擾 UIDL <see cref="Uidl"/>Ŏ擾ł܂B</para>
		''' <para><paramref name="no"/><see cref="UidlAll"/>w肷ƁA
		''' POP3 T[oɂ邷ׂẴ[ UIDL 擾܂B</para>
		''' </remarks>
        Public Sub GetUidl(ByVal no As Integer)
            If _socket = ErrorSocket Then
                Throw New InvalidOperationException
            End If
            SetHeaderSize()
            _uidl = New StringBuilder(_header_size)
            _err = Pop3GetUidl(_socket, no, _uidl, _header_size)
            If _err < 0 Then
                Throw New nMailException("GetUild:" + Options.ErrorMessage, _err)
            End If
        End Sub

		''' <summary>
		''' [wb_w̃tB[h̓e擾܂B
		''' </summary>
		''' <param name="field_name">tB[h</param>
		''' <remarks>
		''' POP3 T[oƂ̐ڑƂ͖֌WɎgpł܂B
		''' <para>wb_́A<see cref="Header"/>Őݒ肵Ă܂B
		''' <see cref="GetMail"/>ŎMɌĂяoꍇA
		''' M[̃wb_gp܂B</para>
		''' <para>擾tB[he<see cref="Field"/>Ŏ擾ł܂B</para>
		''' </remarks>
        Public Sub GetHeaderField(ByVal field_name As String)
            _field_name = field_name
            SetHeaderSize()
            _field = New StringBuilder(_header_size)
            _err = Pop3GetHeaderField(_field, _header.ToString(), _field_name, _header_size)
            If _err < 0 Then
                Throw New nMailException("GetHeaderField", _err)
            End If
        End Sub

		''' <summary>
		''' POP3 |[gԍłB
		''' </summary>
		''' <value>POP3 |[gԍ</value>
        Public Property Port() As Integer
            Get
                Return _port
            End Get
            Set(ByVal Value As Integer)
                _port = Value
            End Set
        End Property

		''' <summary>
		''' \PbgnhłB
		''' </summary>
		''' <value>\Pbgnh</value>
        Public ReadOnly Property Handle() As Integer
            Get
                Return _socket
            End Get
        End Property

		''' <summary>
		''' POP3 T[õ[łB
		''' </summary>
		''' <value>POP3 T[õ[</value>
        Public ReadOnly Property Count() As Integer
            Get
                Return _count
            End Get
        End Property

		''' <summary>
		''' [̃TCYTCYłB
		''' </summary>
		''' <value>[̃TCY</value>
        Public ReadOnly Property Size() As Integer
            Get
                Return _size
            End Get
        End Property

		''' <summary>
		''' POP3 T[ołB
		''' </summary>
		''' <value>POP3 T[o</value>
        Public Property HostName() As String
            Get
                Return _host
            End Get
            Set(ByVal Value As String)
                _host = Value
            End Set
        End Property

		''' <summary>
		''' POP3 [U[łB
		''' </summary>
		''' <value>POP3 [U[</value>
        Public Property Id() As String
            Get
                Return _id
            End Get
            Set(ByVal Value As String)
                _id = Value
            End Set
        End Property

		''' <summary>
		''' POP3 pX[hłB
		''' </summary>
		''' <value>POP3 pX[h</value>
        Public Property Password() As String
            Get
                Return _password
            End Get
            Set(ByVal Value As String)
                _password = Value
            End Set
        End Property

		''' <summary>
		''' Ytt@CۑtH_łB
		''' </summary>
		''' <remarks>
		''' ""  null ̏ꍇۑ܂B
		''' </remarks>
		''' <value>Ytt@CۑtH_</value>
        Public Property Path() As String
            Get
                Return _path
            End Get
            Set(ByVal Value As String)
                _path = Value
            End Set
        End Property

		''' <summary>
		''' [̖{łB
		''' </summary>
		''' <value>[{</value>
        Public ReadOnly Property Body() As String
            Get
                Return _body.ToString()
            End Get
        End Property

		''' <summary>
		''' [̌łB
		''' </summary>
		''' <value>[̌</value>
        Public ReadOnly Property Subject() As String
            Get
                Return _subject.ToString()
            End Get
        End Property

		''' <summary>
		''' [̑M̕łB
		''' </summary>
		''' <value>[M</value>
        Public ReadOnly Property DateString() As String
            Get
                Return _date.ToString()
            End Get
        End Property

		''' <summary>
		''' [̍olłB
		''' </summary>
		''' <value>[̍ol</value>
        Public ReadOnly Property From() As String
            Get
                Return _from.ToString()
            End Get
        End Property

		''' <summary>
		''' [̃wb_łB
		''' </summary>
		''' <value>[̃wb_</value>
        Public Property Header() As String
            Get
                Return _header.ToString()
            End Get
            Set(ByVal Value As String)
                _header = New StringBuilder(Value)
            End Set
        End Property

		''' <summary>
		''' Ytt@CłB
		''' </summary>
		''' <remarks>
		''' ̓Ytt@CꍇA"," ŋ؂Ċi[܂B
		''' <see cref="Options.SplitChar"/>ŋ؂蕶ύXł܂B
		''' </remarks>
		''' <value>Ytt@C</value>
        Public ReadOnly Property FileName() As String
            Get
                Return _filename.ToString()
            End Get
        End Property

		''' <summary>
		''' Ytt@C̔złB
		''' </summary>
		''' <value>Ytt@C</value>
        Public ReadOnly Property FileNameList() As String()
            Get
                Return _filename_list
            End Get
        End Property

		''' <summary>
		''' wb_̃tB[hłB
		''' </summary>
		''' <value>wb_̃tB[h</value>
        Public ReadOnly Property FieldName() As String
            Get
                Return _field_name
            End Get
        End Property

		''' <summary>
		''' wb_tB[h̓ełB
		''' </summary>
		''' <value>wb_tB[h̓e</value>
        Public ReadOnly Property Field() As String
            Get
                Return _field.ToString()
            End Get
        End Property

		''' <summary>
		''' Ytt@C̕łB
		''' </summary>
		''' <value>Ytt@C̕</value>
        Public ReadOnly Property PartNo() As Integer
            Get
                Return _part_no
            End Get
        End Property

		''' <summary>
		''' Ytt@C ID łB
		''' </summary>
		''' <value>Ytt@C ID </value>
        Public ReadOnly Property PartId() As String
            Get
                Return _part_id.ToString()
            End Get
        End Property

		''' <summary>
		''' [ UIDL łB
		''' </summary>
		''' <value>[ UIDL</value>
        Public ReadOnly Property Uidl() As String
            Get
                Return _uidl.ToString()
            End Get
        End Property

		''' <summary>
		''' APOP gp邩ǂ̃tOłB
		''' </summary>
		''' <remarks>
		''' true  APOP gp܂B
		''' </remarks>
		''' <value>APOP gp邩ǂ̃tO</value>
        Public Property APop() As Boolean
            Get
                Return _apop
            End Get
            Set(ByVal Value As Boolean)
                _apop = Value
            End Set
        End Property

		''' <summary>
		''' [g@\wtOłB
		''' </summary>
		''' <remarks>
		''' <para><see cref="PartialAttachmentFile"/>ꂽYtt@C擾܂B</para>
		''' <para><see cref="TextOnly"/>[{̂ݎ擾܂B</para>
		''' <para><see cref="SuspendAttachmentFile"/>Ytt@CMňꎞx~̈ڂɎw肵܂B</para>
		''' <para><see cref="SuspendNext"/>Ytt@CMňꎞx~̓ڈȍ~Ɏw肵܂B</para>
		''' </remarks>
        Public Property Flag() As Integer
            Get
                Return _flag
            End Get
            Set(ByVal Value As Integer)
                _flag = Value
            End Set
        End Property

		''' <summary>
		''' G[ԍłB
		''' </summary>
		''' <value>G[ԍ</value>
        Public ReadOnly Property ErrorCode() As Integer
            Get
                Return _err
            End Get
        End Property

    End Class

	''' <summary>
	''' SMTP [MNX
	''' </summary>
    Class Smtp
        Implements IDisposable

		''' <summary>
		''' g@\pobt@̃TCYłB
		''' </summary>
        Protected Const AttachmentTempSize As Integer = 400

		''' <summary>
		''' \PbgG[͔ڑԂłB
		''' </summary>
        Public Const ErrorSocket As Integer = -1
		''' <summary>
		''' F؎sG[łB
		''' </summary>
        Public Const ErrorAuthenticate As Integer = -2
		''' <summary>
		''' ^CAEgG[łB
		''' </summary>
        Public Const ErrorTimeout As Integer = -4
		''' <summary>
		''' Ytt@CI[vsG[łB
		''' </summary>
        Public Const ErrorFileOpen As Integer = -5
		''' <summary>
		''' T[ow肵F،`ɑΉĂ܂B
		''' </summary>
        Public Const ErrorAuthenticateNoSupport As Integer = -8
		''' <summary>
		''' mۃG[łB
		''' </summary>
        Public Const ErrorMemory As Integer = -9
		''' <summary>
		''' ̑̃G[łB
		''' </summary>
        Public Const ErrorEtc As Integer = -10
		''' <summary>
		''' [M̈ꎞx~ԂłB
		''' </summary>
        Public Const ErrorSuspendAttachmentFile As Integer = -20
		''' <summary>
		''' T[rXpł܂B
		''' </summary>
        Public Const ErrorServiceNotAvaliable As Integer = -421
		''' <summary>
		''' [{bNXgpł܂Bigpj
		''' </summary>
        Public Const ErrorMailboxUnavalable As Integer = -450
		''' <summary>
		''' T[oG[łB
		''' </summary>
        Public Const ErrorLocal As Integer = -451
		''' <summary>
		''' VXeeʕsG[łB
		''' </summary>
        Public Const ErrorInsufficientSystemStorage As Integer = -452
		''' <summary>
		''' R}h̕@G[łB
		''' </summary>
        Public Const ErrorSyntax As Integer = -500
		''' <summary>
		''' p[^̕@G[łB
		''' </summary>
        Public Const ErrorParameter As Integer = -501
		''' <summary>
		''' R}hłB
		''' </summary>
        Public Const ErrorCommandNotImplemented As Integer = -502
		''' <summary>
		''' R}h̃V[PXُłB
		''' </summary>
        Public Const ErrorBadSequence As Integer = -503
		''' <summary>
		''' SMTP F؎słB
		''' </summary>
        Public Const ErrorSmtpAuthenticate As Integer = -535
		''' <summary>
		''' M悪܂B
		''' </summary>
        Public Const ErrorUserUnkown As Integer = -550
		''' <summary>
		''' [U[݂ȂA]悪܂B
		''' </summary>
        Public Const ErrorUserNotLocal As Integer = -551
		''' <summary>
		''' eʃI[o[G[łB
		''' </summary>
        Public Const ErrorExceededStorageAllocation As Integer = -552
		''' <summary>
		''' [{bNX܂B
		''' </summary>
        Public Const ErrorMailboxNameNotAllowed As Integer = -553
		''' <summary>
		''' [h~G[łB
		''' </summary>
        Public Const ErrorRelayOperationRejected As Integer = -553
		''' <summary>
		''' gUNVɎs܂B
		''' </summary>
        Public Const ErrorTransactionFailed As Integer = -554
		''' <summary>
		''' MtB[h nMail.DLL Ő܂B
		''' </summary>
        Public Const AddDateField As Integer = 1
		''' <summary>
		''' Message-ID tB[h nMail.DLL Ő܂B
		''' </summary>
        Public Const AddMessageId As Integer = 2
		''' <summary>
		''' 傫ȃTCY̓Ytt@CMɈU߂܂B
		''' </summary>
        Public Const SuspendAttachmentFile As Integer = 4
		''' <summary>
		''' 傫ȃTCY̓Ytt@CMڈȍ~łB
		''' </summary>
        Public Const SuspendNext As Integer = 8
		''' <summary>
		''' RFC2231 œYtt@CGR[h܂B
		''' </summary>
        Public Const FileNameRfc2231 As Integer = 16
		''' <summary>
		''' UTF-8 Ń[GR[h܂iBASE64ŃGR[h܂j
		''' </summary>
        Public Const EncodeUtf8 As Integer = 32
		''' <summary>
		''' łB
		''' </summary>
        Public Const Success As Integer = 0
		''' <summary>
		''' SMTP AUTH ͎gp܂B
		''' </summary>
        Public Const AuthNotUse As Integer = 0
		''' <summary>
		''' SMTP AUTH PLAIN gp܂B
		''' </summary>
        Public Const AuthPlain As Integer = 1
		''' <summary>
		''' SMTP AUTH LOGIN gp܂B
		''' </summary>
        Public Const AuthLogin As Integer = 2
		''' <summary>
		''' SMTP AUTH CRAM MD5 gp܂B
		''' </summary>
        Public Const AuthCramMd5 As Integer = 4

		''' <summary>
		''' SMTP |[gԍłB
		''' </summary>
        Protected _port As Integer = 25
		''' <summary>
		''' \PbgnhłB
		''' </summary>
        Protected _socket As Integer = ErrorSocket
		''' <summary>
		''' [Mg@\̎włB
		''' </summary>
        Protected _flag As Integer = 0
		''' <summary>
		''' G[ԍłB
		''' </summary>
        Protected _err As Integer
		''' <summary>
		''' SMTP AUTH ̃[hłB
		''' </summary>
        Protected _mode As Integer = AuthNotUse
		''' <summary>
		''' SMTP T[ołB
		''' </summary>
        Protected _host As String = ""
		''' <summary>
		''' SMTP AUTH [U[łB
		''' </summary>
        Protected _id As String = ""
		''' <summary>
		''' SMTP AUTH pX[hłB
		''' </summary>
        Protected _password As String = ""
		''' <summary>
		''' [̈łB
		''' </summary>
        Protected _to As String = ""
		''' <summary>
		''' [ CC łB
		''' </summary>
        Protected _cc As String = ""
		''' <summary>
		''' [ BCC łB
		''' </summary>
        Protected _bcc As String = ""
		''' <summary>
		''' [̍olłB
		''' </summary>
        Protected _from As String = ""
		''' <summary>
		''' [̌łB
		''' </summary>
        Protected _subject As String = ""
		''' <summary>
		''' [̖{łB
		''' </summary>
        Protected _body As String = ""
		''' <summary>
		''' [̒ǉwb_łB
		''' </summary>
        Protected _header As String = ""
		''' <summary>
		''' [ɓYtt@CłB
		''' </summary>
        Protected _filename As String = ""
		''' <summary>
		''' Ytt@C̃XgłB
		''' </summary>
        Protected _filename_list As String() = nothing
		''' <summary>
		''' g@\pobt@łB
		''' </summary>
        Protected _temp() As Byte
		''' <summary>
		''' Connect() gǂ̃tOłB
		''' </summary>
        Protected _connect_flag As Boolean = false
		''' <summary>
		''' Dispose sǂ̃tOłB
		''' </summary>
        Protected _disposed As Boolean = false

        <DllImport("nMail.DLL", EntryPoint:="NMailSmtpSendMailPortNo", CharSet:=CharSet.Auto)> _
        Protected Shared Function SmtpSendMailPortNo(ByVal HostName As String, ByVal ToStr As String, ByVal Cc As String, ByVal Bcc As String, ByVal From As String, ByVal Subject As String, ByVal Body As String, ByVal Header As String, ByVal Path As String, ByVal Flag As Integer, ByVal PortNo As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailSmtpConnect", CharSet:=CharSet.Auto)> _
        Protected Shared Function SmtpConnect(ByVal Host As String) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailSmtpConnectPortNo", CharSet:=CharSet.Auto)> _
        Protected Shared Function SmtpConnectPortNo(ByVal Host As String, ByVal PortNo As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailSmtpAuthenticate", CharSet:=CharSet.Auto)> _
        Protected Shared Function SmtpAuthenticate(ByVal Socket As Integer, ByVal HostName As String, ByVal Id As String, ByVal Pass As String, ByVal Mode As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailSmtpSendMailEx", CharSet:=CharSet.Auto)> _
        Protected Shared Function SmtpSendMailEx(ByVal Socket As Integer, ByVal ToStr As String, ByVal Cc As String, ByVal Bcc As String, ByVal From As String, ByVal Subject As String, ByVal Body As String, ByVal Header As String, ByVal Path As String, ByVal Temp() As Byte, ByVal Flag As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailSmtpClose")> _
        Protected Shared Function SmtpClose(ByVal Socket As Integer) As Boolean
        End Function

		''' <summary>
		''' łB
		''' </summary>
        Protected Sub Init()
            _temp = New Byte(AttachmentTempSize) {}
            _filename_list = Nothing
        End Sub

		''' <summary>
		''' <c>Smtp</c>NX̐VKCX^X܂B
		''' </summary>
        Public Sub New()
            Init()
        End Sub

		''' <summary>
		''' <c>Smtp</c>NX̐VKCX^X܂B
		''' </summary>
		''' <param name="host_name">SMTP T[o</param>
        Public Sub New(ByVal host_name As String)
            Init()
            _host = host_name
        End Sub

		''' <summary>
		''' 
		''' </summary>
        Protected Overrides Sub Finalize()
            MyBase.Finalize()
            Dispose(False)
        End Sub

		''' <summary>
		''' <see cref="Smtp"/>ɂĎgpĂ邷ׂẴ\[X܂B
		''' </summary>
        Overridable Overloads Sub Dispose() Implements IDisposable.Dispose
            Dispose(True)
            GC.SuppressFinalize(Me)
        End Sub

		''' <summary>
		''' <see cref="Smtp"/>ɂĎgpĂ邷ׂẴ\[X܂B
		''' </summary>
		''' <param name="disposing">
		''' }l[W\[XƃA}l[W\[X̗ꍇ<c>true</c>B
		''' A}l[W\[Xꍇ<c>false</c>B
		''' </param>
        Protected Overloads Sub Dispose(ByVal disposing As Boolean)
            If Not _disposed Then
                If disposing Then
                End If
                If _connect_flag And (_socket <> ErrorSocket) Then
                    SmtpClose(_socket)
                End If
                _socket = ErrorSocket
                _connect_flag = False
                _disposed = True
            End If
        End Sub

		''' <summary>
		''' [𑗐M܂B
		''' </summary>
		''' <remarks>
		'''	ꎞx~@\̓ڈȍ~̌ĂяoŎgp܂B
		''' </remarks>
        Public Sub SendMail()
            Dim no As Integer

            _filename = ""
			If not _filename_list is nothing then
                If _filename_list.Length > 0 Then
                    For no = 0 To _filename_list.Length - 1
                        If Not File.Exists(_filename_list(no)) Then
                            Throw New FileNotFoundException(_filename_list(no))
                        End If
                    Next no
                    _filename = String.Join(Options.SplitChar, _filename_list)
                End If
            End If
            If _connect_flag Then
                _err = SmtpSendMailEx(_socket, _to, _cc, _bcc, _from, _subject, _body, _header, _filename, _temp, _flag)
            Else
                _err = SmtpSendMailPortNo(_host, _to, _cc, _bcc, _from, _subject, _body, _header, _filename, _flag, _port)
            End If
            If (_err < 0) And (_err <> ErrorSuspendAttachmentFile) Then
                Throw New nMailException("SendMail:" + Options.ErrorMessage, _err)
            End If
        End Sub

		''' <summary>
		''' [𑗐M܂B
		''' </summary>
		''' <param name="to_str"></param>
		''' <param name="from_str">ol</param>
		''' <param name="subject_str"></param>
		''' <param name="body_str">{</param>
		''' <remarks>
		''' <paramref name="to_str"/>p[^Ń[̈w肵܂B
		''' <paramref name="from_str"/>p[^ōolw肵܂B
		''' <paramref name="subject_str"/>p[^Ōw肵܂B
		''' <paramref name="body_str"/>p[^Ŗ{w肵܂B
		''' <para>CC w肵ꍇA<see cref="Cc"/>Ɏw肵Ă܂B</para>
		''' <para>BCC w肵ꍇA<see cref="Bcc"/>Ɏw肵Ă܂B</para>
		''' <para>t@CYtꍇA<see cref="FileName"/>Ɏw肵Ă܂B</para>
		''' </remarks>
        Public Sub SendMail(ByVal to_str As String, ByVal from_str As String, ByVal subject_str As String, ByVal body_str As String)
            _to = to_str
            _from = from_str
            _subject = subject_str
            _body = body_str
            SendMail()
        End Sub

		''' <summary>
		''' SMTP T[oɐڑ܂B
		''' </summary>
		''' <remarks>
		'''	SMTP AUTH шꎞx~@\gꍇɎgp܂B
		''' </remarks>
        Public Sub Connect()
            If _host = "" Then
                Throw New FormatException
            End If
            If (_port < 0) Or (_port > 65536) Then
                Throw New ArgumentOutOfRangeException
            End If
            _socket = SmtpConnectPortNo(_host, _port)
            If (_socket = ErrorSocket) Or (_socket = ErrorTimeout) Then
                _err = _socket
                _socket = ErrorSocket
                Throw New nMailException("Connect", _err)
            Else
                _connect_flag = True
            End If
        End Sub

		''' <summary>
		''' SMTP T[oɐڑ
		''' </summary>
		''' <param name="host_name">SMTP T[o</param>
		''' <remarks>
		'''	SMTP AUTH шꎞx~@\gꍇɎgp܂B
		''' </remarks>
        Public Sub Connect(ByVal host_name As String)
            _host = host_name
            Connect()
        End Sub

		''' <summary>
		''' SMTP T[oɐڑ
		''' </summary>
		''' <param name="host_name">SMTP T[o</param>
		''' <param name="port_no">|[gԍ</param>
		''' <remarks>
		'''	SMTP AUTH шꎞx~@\gꍇɎgp܂B
		''' </remarks>
        Public Sub Connect(ByVal host_name As String, ByVal port_no As Integer)
            _host = host_name
            _port = port_no
            Connect()
        End Sub

		''' <summary>
		''' SMTP T[oɐڑ
		''' </summary>
		''' <param name="port_no">|[gԍ</param>
		''' <remarks>
		'''	SMTP AUTH шꎞx~@\gꍇɎgp܂B
		''' </remarks>
        Public Sub Connect(ByVal port_no As Integer)
            _port = port_no
            Connect()
        End Sub

		''' <summary>
		''' SMTP T[oƂ̐ڑI
		''' </summary>
        Public Sub Close()
            If _socket <> ErrorSocket Then
                SmtpClose(_socket)
            End If
            _socket = ErrorSocket
            _connect_flag = False
        End Sub

		''' <summary>
		''' SMTP AUTH F
		''' </summary>
        Public Sub Authenticate()
            If _socket = ErrorSocket Then
                Throw New InvalidOperationException
            End If
            _err = SmtpAuthenticate(_socket, _host, _id, _password, _mode)
            If _err < 0 Then
                Throw New nMailException("Authenticate:" + Options.ErrorMessage, _err)
            End If
        End Sub

		''' <summary>
		''' SMTP AUTH F
		''' </summary>
		''' <param name="id_str">[U[ ID</param>
		''' <param name="pass_str">pX[h</param>
		''' <param name="mode">AUTH </param>
		''' <remarks>
		''' AUTH ʂ̐ݒ\Ȓl͉L̒ʂłB
		''' <see cref="AuthPlain"/>  PLAIN gp܂B
		''' <see cref="AuthLogin"/>  LOGIN gp܂B
		''' <see cref="AuthCramMd5"/> CRAM MD5 gp܂B
		''' AuthNotUse ȊO Or ŕw\łB
		''' CRAM MD5LOGINPLAIN ̗D揇ʂŔF؂݂܂B
		''' </remarks>
        Public Sub Authenticate(ByVal id_str As String, ByVal pass_str As String, ByVal mode As Integer)
            _id = id_str
            _password = pass_str
            _mode = mode
            Authenticate()
        End Sub

		''' <summary>
		''' SMTP |[gԍłB
		''' </summary>
		''' <value>SMTP |[gԍ</value>
        Public Property Port() As Integer
            Get
                Return _port
            End Get
            Set(ByVal Value As Integer)
                _port = Value
            End Set
        End Property

		''' <summary>
		''' \PbgnhłB
		''' </summary>
		''' <value>SMTP \Pbgnh</value>
        Public ReadOnly Property Handle() As Integer
            Get
                Return _socket
            End Get
        End Property

		''' <summary>
		''' SMTP T[ołB
		''' </summary>
		''' <value>SMTP T[o</value>
        Public Property HostName() As String
            Get
                Return _host
            End Get
            Set(ByVal Value As String)
                _host = Value
            End Set
        End Property

		''' <summary>
		''' SMTP AUTH p̃[U[łB
		''' </summary>
		''' <value>SMTP AUTH [U[</value>
        Public Property Id() As String
            Get
                Return _id
            End Get
            Set(ByVal Value As String)
                _id = Value
            End Set
        End Property

		''' <summary>
		''' SMTP AUTH p̃pX[hłB
		''' </summary>
		''' <value>SMTP AUTH pX[h</value>
        Public Property Password() As String
            Get
                Return _password
            End Get
            Set(ByVal Value As String)
                _password = Value
            End Set
        End Property

		''' <summary>
		''' [̈łB
		''' </summary>
		''' <value>[ </value>
        Public Property MailTo() As String
            Get
                Return _to
            End Get
            Set(ByVal Value As String)
                _to = Value
            End Set
        End Property

		''' <summary>
		''' [ CC łB
		''' </summary>
		''' <value>[ CC</value>
        Public Property Cc() As String
            Get
                Return _cc
            End Get
            Set(ByVal Value As String)
                _cc = Value
            End Set
        End Property

		''' <summary>
		''' [ BCC łB
		''' </summary>
		''' <value>[ BCC</value>
        Public Property Bcc() As String
            Get
                Return _bcc
            End Get
            Set(ByVal Value As String)
                _bcc = Value
            End Set
        End Property

		''' <summary>
		''' [̍olłB
		''' </summary>
		''' <value>[ol</value>
        Public Property From() As String
            Get
                Return _from
            End Get
            Set(ByVal Value As String)
                _from = Value
            End Set
        End Property

		''' <summary>
		''' [̌łB
		''' </summary>
		''' <value>[</value>
        Public Property Subject() As String
            Get
                Return _subject
            End Get
            Set(ByVal Value As String)
                _subject = Value
            End Set
        End Property

		''' <summary>
		''' [̖{łB
		''' </summary>
		''' <value>[{</value>
        Public Property Body() As String
            Get
                Return _body
            End Get
            Set(ByVal Value As String)
                _body = Value
            End Set
        End Property

		''' <summary>
		''' [̓Ytt@CłB
		''' </summary>
		''' <remarks>
		''' ̓Ytt@C𑗐MꍇA"," ŋ؂܂B
		''' <see cref="Options.SplitChar"/>ŋ؂蕶ύXł܂B
		''' </remarks>
		''' <value>Ytt@C</value>
        Public Property FileName() As String
            Get
                _filename = String.Join(Options.SplitChar, _filename_list)
                Return _filename
            End Get
            Set(ByVal Value As String)
                _filename = Value
                If _filename.Length > 0 Then
                    _filename_list = _filename.ToString().Split(Options.SplitChar)
                Else
                    _filename_list = New String(0) {}
                End If
            End Set
        End Property

		''' <summary>
		''' Ytt@C̔złB
		''' </summary>
		''' <value>Ytt@C</value>
        Public Property FileNameList() As String()
            Get
                Return _filename_list
            End Get
            Set(ByVal Value As String())
                _filename_list = Value
            End Set
        End Property

		''' <summary>
		''' [̒ǉwb_łB
		''' </summary>
		''' <remarks>
		''' ̃wb_ǉꍇAC# ł '\r\n'AVisual Basic ł vbCrLf
		''' ŘAĂB
		''' </remarks>
		''' <value>ǉwb_</value>
        Public Property Header() As String
            Get
                Return _header
            End Get
            Set(ByVal Value As String)
                _header = Value
            End Set
        End Property

		''' <summary>
		''' [M̃IvVwłB
		''' </summary>
		''' <value>MIvV</value>
		''' <remarks>
		''' <para><see cref="AddDateField"/>MtB[h nMail.DLL Ő܂B</para>
		''' <para><see cref="AddMessageId"/>Message-ID tB[h nMail.DLL Ő܂B</para>
		''' <para><see cref="SuspendAttachmentFile"/>Ytt@CMňꎞx~̈ڂɎw肵܂B</para>
		''' <para><see cref="SuspendNext"/>Ytt@CMňꎞx~̓ڈȍ~Ɏw肵܂B</para>
		'''	<para><see cref="FileNameRfc2231"/>RFC2231 œYtt@CGR[h܂B</para>
		''' <para><see cref="EncodeUtf8"/>UTF-8 Ń[GR[h܂iBASE64ŃGR[h܂j</para>
		''' <para>C# ̏ꍇ |AVB.NET ̏ꍇ Or ŕ̎w肪\łB SuspendAttachmentFile  SuspendNext ͓Ɏwł܂B</para>
		''' </remarks>
        Public Property Flag() As Integer
            Get
                Return _flag
            End Get
            Set(ByVal Value As Integer)
                _flag = Value
            End Set
        End Property

		''' <summary>
		''' SMTP AUTH ̎ʂłB
		''' </summary>
		''' <remarks>
		''' <see cref="AuthNotUse"/>  SMTP AUTH ͎gp܂B
		''' <see cref="AuthPlain"/>  PLAIN gp܂B
		''' <see cref="AuthLogin"/>  LOGIN gp܂B
		''' <see cref="AuthCramMd5"/> CRAM MD5 gp܂B
		''' AuthNotUse ȊO C#  | AVisual Basic ł or ŕݒ\łB
		''' CRAM MD5LOGINPLAIN ̏ԂŔF؂݂܂B
		'''	ftHgl AuthNotUse łB
		''' </remarks>
		''' <value>M[h</value>
        Public Property AuthMode() As Integer
            Get
                Return _mode
            End Get
            Set(ByVal Value As Integer)
                _mode = Value
            End Set
        End Property

		''' <summary>
		''' [M̃G[ԍłB
		''' </summary>
		''' <value>G[ԍ</value>
        Public ReadOnly Property ErrorCode() As Integer
            Get
                Return _err
            End Get
        End Property
    End Class

	''' <summary>
	''' Ytt@CWJNX
	''' </summary>
    Class Attachment
        Implements IDisposable
		''' <summary>
		''' wb_̈̃TCYłB
		''' </summary>
        Protected Const HeaderSize As Integer = 32768
		''' <summary>
		''' pX̃TCYłB
		''' </summary>
        Protected Const MaxPath As Integer = 32768
		''' <summary>
		''' Ytt@CWJpobt@̃TCYłB
		''' </summary>
        Protected Const AttachmentTempSize As Integer = 400

		''' <summary>
		''' ꂽYtt@C̏Ԃ܂B
		''' </summary>
        Public Const ErrorInvalidNo As Integer = -3
		''' <summary>
		''' Ytt@C쐬ł܂łB
		''' </summary>
        Public Const ErrorFileOpen As Integer = -5
		''' <summary>
		''' Ytt@C̓WJIĂ܂B
		''' </summary>
        Public Const ErrorPartial As Integer = -6
		''' <summary>
		''' Ytt@CƓ̃t@CtH_ɑ݂܂B
		''' </summary>
		''' <remarks>
		''' <para><see cref="nMail.Options.AlreadyFile"/>  <see cref="nMail.Options.FileAlreadyError"/></para>
		''' <para>ݒ肵A<see cref="Path"/>Ŏw肵tH_ɓYtt@CƓÕt@C</para>
		''' <para>ꍇɂ̃G[܂B</para>
		''' </remarks>
        Public Const ErrorFileAlready As Integer = -7
		''' <summary>
		''' mۃG[łB
		''' </summary>
        Public Const ErrorMemory As Integer = -9
		''' <summary>
		''' ̑̃G[łB
		''' </summary>
        Public Const ErrorEtc As Integer = -10
		''' <summary>
		''' Ytt@C݂͑܂B
		''' </summary>
        Public Const NoAttachmentFile As Integer = -1

		''' <summary>
		''' wb_f[^̃Xg
		''' </summary>
        Protected _header_list As ArrayList
		''' <summary>
		''' {f[^̃Xg
		''' </summary>
        Protected _body_list As ArrayList

		''' <summary>
		''' wb_[TCYłB
		''' </summary>
        Protected _header_size As Integer = -1
		''' <summary>
		''' G[ԍłB
		''' </summary>
        Protected _err As Integer
		''' <summary>
		''' Ytt@CۑpXłB
		''' </summary>
        Protected _path As String = ""
		''' <summary>
		''' [̌łB
		''' </summary>
        Protected _subject As StringBuilder
		''' <summary>
		''' [̑MłB
		''' </summary>
        Protected _date As StringBuilder
		''' <summary>
		''' [̍olłB
		''' </summary>
        Protected _from As StringBuilder
		''' <summary>
		''' [̃wb_łB
		''' </summary>
        Protected _header As StringBuilder
		''' <summary>
		''' [̖{łB
		''' </summary>
        Protected _body As StringBuilder
		''' <summary>
		''' WJYtt@CłB
		''' </summary>
        Protected _filename As StringBuilder
		''' <summary>
		''' Ytt@C̃XgłB
		''' </summary>
        Protected _filename_list As String() = Nothing
		''' <summary>
		''' t@C ID łB
		''' </summary>
        Protected _id As StringBuilder
		''' <summary>
		''' Ytt@CWJpobt@łB
		''' </summary>
        Protected _temp() As Byte
		''' <summary>
		''' WJJnǂ̃tOłB
		''' </summary>
		private _attachment_flag as boolean = false
		''' <summary>
		''' Dispose sǂ̃tOłB
		''' </summary>
		private _disposed as boolean = false

        <DllImport("nMail.DLL", EntryPoint:="NMailAttachmentFileFirst", CharSet:=CharSet.Auto)> _
        Protected Shared Function AttachmentFileFirst(ByVal Temp() As Byte, ByVal Subject As StringBuilder, ByVal DateStr As StringBuilder, ByVal From As StringBuilder, ByVal Header As StringBuilder, ByVal Body As StringBuilder, ByVal Path As String, ByVal FileName As StringBuilder, ByVal FirstHeader As String, ByVal FirstBody As String) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailAttachmentFileNextVB", CharSet:=CharSet.Auto)> _
        Protected Shared Function AttachmentFileNextVB(ByVal Temp() As Byte, ByVal Subject As StringBuilder, ByVal DateStr As StringBuilder, ByVal From As StringBuilder, ByVal Header As StringBuilder, ByVal Body As StringBuilder, ByVal Path As String, ByVal FileName As StringBuilder, ByVal NextHeader As String, ByVal NextBody As String) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailAttachmentFileClose")> _
        Protected Shared Function AttachmentFileClose(ByVal Temp() As Byte) As Boolean
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailAttachmentFileStatus", CharSet:=CharSet.Auto)> _
        Protected Shared Function AttachmentFileStatus(ByVal Header As String, ByVal Id As StringBuilder, ByVal Size As Integer) As Integer
        End Function

		''' <summary>
		''' wb_i[pobt@̃TCY肵܂B
		''' </summary>
        Protected Sub SetHeaderSize()
            If _header_size < 0 Then
                _header_size = Options.HeaderMax
            End If
            If _header_size <= 0 Then
                _header_size = HeaderSize
                Options.HeaderMax = _header_size
            End If
        End Sub

		''' <summary>
		''' <c>Attachment</c>NX̐VKCX^X܂B
		''' </summary>
        Public Sub New()
            _header_list = New ArrayList
            _body_list = New ArrayList
            _temp = New Byte(AttachmentTempSize) {}
        End Sub

		''' <summary>
		''' 
		''' </summary>
        Protected Overrides Sub Finalize()
            MyBase.Finalize()
            Dispose(False)
        End Sub

		''' <summary>
		''' <see cref="Attachment"/>ɂĎgpĂ邷ׂẴ\[X܂B
		''' </summary>
        Overridable Overloads Sub Dispose() Implements IDisposable.Dispose
            Dispose(True)
            GC.SuppressFinalize(Me)
        End Sub

		''' <summary>
		''' <see cref="Attachment"/>ɂĎgpĂ邷ׂẴ\[X܂B
		''' </summary>
		''' <param name="disposing">
		''' }l[W\[XƃA}l[W\[X̗ꍇ<c>true</c>B
		''' A}l[W\[Xꍇ<c>false</c>B
		''' </param>
        Protected Overloads Sub Dispose(ByVal disposing As Boolean)
            If Not _disposed Then
                If disposing Then
                End If
				if _attachment_flag then
					AttachmentFileClose(_temp)
					_attachment_flag = false
				end if
                _disposed = True
            End If
        End Sub

        Public Sub Close()
			if _attachment_flag then
				AttachmentFileClose(_temp)
				_attachment_flag = false
			end if
		end sub

		''' <summary>
		''' [{̍vTCY擾܂B
		''' </summary>
		''' <returns>[{̍vTCY</returns>
        Protected Function GetBodySize() As Integer
            Dim size As Integer = 0
            Dim str As String
            Dim no As Integer

            For no = 0 To _header_list.Count - 1
                If no < _body_list.Count Then
                    str = CStr(_body_list(no))
                    size += str.Length
                End If
                str = CStr(_header_list(no))
                size += str.Length
            Next no
            Return size
        End Function

		''' <summary>
		''' Ytt@CWJĕۑ܂B
		''' </summary>
        '''	<see cref="Add"/>ŌƂȂ镶iwb_,{)ǉĂ܂B
        Public Sub Save()
            Dim read_body As String
            Dim read_header As String
			dim keep_id as string = ""
            Dim no As Integer
			dim id_no as integer = -1

            If (_path <> "") And (Not Directory.Exists(_path)) Then
                Throw New DirectoryNotFoundException(_path)
            End If

            SetHeaderSize()

            _subject = New StringBuilder(_header_size)
            _date = New StringBuilder(_header_size)
            _from = New StringBuilder(_header_size)
            _header = New StringBuilder(_header_size)
            _body = New StringBuilder(GetBodySize())
            _filename = New StringBuilder(MaxPath)

            If (_header_list.Count <> _body_list.Count) And (_body_list.Count > 0) Then
                Throw New FormatException
            End If
            For no = 0 To _header_list.Count - 1
                If no < _body_list.Count Then
                    read_body = CStr(_body_list(no))
                Else
                    read_body = ""
                End If
                read_header = CStr(_header_list(no))
                If no = 0 Then
                    id_no = GetId(read_header)
                    If id_no > 1 Then
                        Throw New nMailException("Save", ErrorInvalidNo)
                    End If
					keep_id = PartId
                    _attachment_flag = True
                    _err = AttachmentFileFirst(_temp, _subject, _date, _from, _header, _body, _path, _filename, read_header, read_body)
                Else
                    If (GetId(read_header) <> no + 1) Or (keep_id <> PartId) Then
                        Throw New nMailException("Save", ErrorInvalidNo)
                    End If
                    _err = AttachmentFileNextVB(_temp, _subject, _date, _from, _header, _body, _path, _filename, read_header, read_body)
                End If
                If (_err < 0) And (_err <> ErrorPartial) Then
                    Throw New nMailException("Save", _err)
                End If
            Next no
            AttachmentFileClose(_temp)
            _attachment_flag = False
        End Sub

		''' <summary>
		''' WJƂȂ镪t@Cf[^Xgɒǉ܂B
		''' </summary>
		''' <param name="header_body">wb_[{{̕</param>
		''' <remarks>
		'''	wb_Ɩ{̊Ԃɂ͈s̋sKvłB
		''' </remarks>
        Public Sub Add(ByVal header_body As String)
            _header_list.Add(header_body)
        End Sub

		''' <summary>
		''' WJƂȂ镪t@Cf[^Xgɒǉ܂B
		''' </summary>
		''' <param name="header">wb_[̕</param>
		''' <param name="body">{̕</param>
        Public Sub Add(ByVal header As String, ByVal body As String)
            _header_list.Add(header)
            _body_list.Add(body)
        End Sub

		''' <summary>
		''' t@C ID 擾܂B
		''' </summary>
		''' <param name="header">wb_[̕</param>
		''' <returns><see cref="NoAttachmentFile"/>̏ꍇĂȂYtt@Ct[łB
		''' 1 ȏ̏ꍇAt@C̔ԍƂȂ܂B
		''' </returns>
        Public Function GetId(ByVal header As String) As Integer
            _id = New StringBuilder(header.Length)
            Return AttachmentFileStatus(header, _id, header.Length)
        End Function

		''' <summary>
		''' 
		''' </summary>
		''' <value>[</value>
        Public ReadOnly Property Subject() As String
            Get
                Return _subject.ToString()
            End Get

        End Property
		''' <summary>
		''' [̑M̕łB
		''' </summary>
		''' <value>[M</value>
        Public ReadOnly Property DateString() As String
            Get
                Return _date.ToString()
            End Get
        End Property

		''' <summary>
		''' [̍olłB
		''' </summary>
		''' <value>[ol</value>
        Public ReadOnly Property From() As String
            Get
                Return _from.ToString()
            End Get
        End Property

		''' <summary>
		''' [̖{łB
		''' </summary>
		''' <value>[{</value>
        Public ReadOnly Property Body() As String
            Get
                Return _body.ToString()
            End Get
        End Property

		''' <summary>
		''' Ytt@CۑtH_łB
		''' </summary>
		''' <remarks>
		''' ""  null ̏ꍇۑ܂B
		''' </remarks>
		''' <value>Ytt@CۑtH_</value>
        Public Property Path() As String
            Get
                Return _path
            End Get
            Set(ByVal Value As String)
                _path = Value
            End Set
        End Property

		''' <summary>
		''' t@C ID łB
		''' </summary>
		''' <value>t@C ID</value>
        Public ReadOnly Property PartId() As String
            Get
                Return _id.ToString()
            End Get
        End Property

		''' <summary>
		''' Ytt@CłB
		''' </summary>
		''' <remarks>
		''' ̓Ytt@CꍇA"," ŋ؂Ċi[܂B
		''' <see cref="Options.SplitChar"/>ŋ؂蕶ύXł܂B
		''' </remarks>
		''' <value>Ytt@C</value>
        Public ReadOnly Property FileName() As String
            Get
                Return _filename.ToString()
            End Get
        End Property

		''' <summary>
		''' Ytt@C̔złB
		''' </summary>
		''' <value>Ytt@C</value>
        Public ReadOnly Property FileNameList() As String()
            Get
                If _filename.Length > 0 Then
                    _filename_list = _filename.ToString().Split(Options.SplitChar)
                Else
                    _filename_list = New String(0) {}
                End If
                Return _filename_list
            End Get
        End Property

		''' <summary>
		''' G[ԍ
		''' </summary>
		''' <value>G[ԍ</value>
        Public ReadOnly Property ErrorCode() As Integer
            Get
                Return _err
            End Get
        End Property

    End Class

    Class Options

		''' <summary>
		''' 
		''' </summary>
        Protected Const MessageSize As Integer = 32768

		''' <summary>
		''' IvVF^CAEg
		''' </summary>
        Protected Const OptionTimeout As Integer = 0
		''' <summary>
		''' IvVFwb_TCY
		''' </summary>
        Protected Const OptionHeaderMax As Integer = 1
		''' <summary>
		''' IvVF{TCY
		''' </summary>
        Protected Const OptionBodyMax As Integer = 2
		''' <summary>
		''' IvVF㏑[h
		''' </summary>
        Protected Const OptionAlreadyFile As Integer = 3
		''' <summary>
		''' IvVFfobN[h
		''' </summary>
        Protected Const OptionDebugMode As Integer = 4
		''' <summary>
		''' IvVFڑ^CAEg
		''' </summary>
        Protected Const OptionConnectTimeout As Integer = 5
		''' <summary>
		''' IvVF؂蕶
		''' </summary>
        Protected Const OptionSplitChar As Integer = 6
		''' <summary>
		''' IvVFꎞx~TCY
		''' </summary>
        Protected Const OptionSuspendSize As Integer = 7
		''' <summary>
		''' IvVFSleep 
		''' </summary>
        Protected Const OptionSleepTime As Integer = 8
		''' <summary>
		''' IvVFtB[hTCY
		''' </summary>
        Protected Const OptionFieldMax As Integer = 9

		''' <summary>
		''' t@C㏑
		''' </summary>
        Public Const FileOverwrite As Integer = 1
		''' <summary>
		''' ɐt
		''' </summary>
        Public Const FileRename As Integer = 2
		''' <summary>
		''' t@C쐬G[Ƃ
		''' </summary>
        Public Const FileAlreadyError As Integer = 3

		''' <summary>
		''' 
		''' </summary>
        Public Const MessageError As Integer = 0
		''' <summary>
		''' 
		''' </summary>
        Public Const MessageDebug As Integer = 1

		''' <summary>
		''' 
		''' </summary>
        Public Const DebugStart As Integer = 1
		''' <summary>
		''' 
		''' </summary>
        Public Const DebugEnd As Integer = 0

		''' <summary>
		''' 
		''' </summary>
        Public Const ConnectTimeoutOn As Integer = 1
		''' <summary>
		''' 
		''' </summary>
        Public Const ConnectTimeoutOff As Integer = 1

        <DllImport("nMail.DLL", EntryPoint:="NMailGetVersion")> _
        Public Shared Function GetVersion() As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailGetOption")> _
        Public Shared Function GetOption(ByVal opt As Integer) As Integer
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailSetOption")> _
        Public Shared Function SetOption(ByVal opt As Integer, ByVal value As Integer) As Boolean
        End Function

        <DllImport("nMail.DLL", EntryPoint:="NMailGetMessage", CharSet:=CharSet.Auto)> _
        Public Shared Sub GetMessage(ByVal Type As Integer, ByVal Message As StringBuilder, ByVal Size As Integer)
        End Sub

        <DllImport("nMail.DLL", EntryPoint:="NMailGetSuspendNumber", CharSet:=CharSet.Auto)> _
        Public Shared Function GetSuspendNumber(ByVal Path As String) As Integer
        End Function

        ''' <summary>
        ''' fobN[hJn܂B
        ''' </summary>
        ''' <remarks>
        ''' <see cref="EndDebug"/>Ăяo <see cref="DebugMessage"/>
        ''' QƂ邱ƂɂăT[oƂ̌M擾ł܂B
        ''' </remarks>
        Public Shared Sub StartDebug()
            SetOption(OptionDebugMode, DebugStart)
        End Sub

        ''' <summary>
        ''' fobN[hI܂B
        ''' </summary>
        ''' <remarks>
        ''' Ăяo <see cref="DebugMessage"/> QƂ邱ƂɂăT[o
        ''' Ƃ̌M擾ł܂B
        ''' </remarks>
        Public Shared Sub EndDebug()
            SetOption(OptionDebugMode, DebugEnd)
        End Sub

        ''' <summary>
        ''' ڑ^CAEgݒLɂ܂B
        ''' </summary>
        Public Shared Sub EnableConnectTimeout()
            SetOption(OptionConnectTimeout, ConnectTimeoutOn)
        End Sub

        ''' <summary>
        ''' ڑ^CAEgݒ𖳌ɂ܂B
        ''' </summary>
        Public Shared Sub DisableConnectTimeout()
            SetOption(OptionConnectTimeout, ConnectTimeoutOff)
        End Sub

        ''' <summary>
        ''' w肳ꂽt@CYt[𑗐Mꍇ̋x~񐔂𓾂
        ''' </summary>
        ''' <param name="file_name">Ytt@C</param>
        ''' <returns>w肳ꂽt@CYt[𑗐Mꍇ̋x~񐔂𓾂</returns>
        Public Shared Function SuspendCount(ByVal file_name As String) As Integer
            If Not File.Exists(file_name) Then
                Throw New FileNotFoundException
            End If
            Return GetSuspendNumber(file_name)
        End Function

        ''' <summary>
        ''' o[W̐lłB
        ''' </summary>
        ''' <remarks>
        ''' nMail.DLL ̃o[W̐lłB
        ''' Version 1.23 ̏ꍇ 123 ƂȂ܂B
        ''' </remarks>
        ''' <value>o[Wl</value>
        Public Shared ReadOnly Property VersionInt() As Integer
            Get
                Return GetVersion()
            End Get
        End Property

        ''' <summary>
        ''' o[W̕łB
        ''' </summary>
        ''' <remarks>
        ''' nMail.DLL ̃o[W̕łB
        ''' Version 1.23 ̏ꍇ "1.23" ƂȂ܂B
        ''' </remarks>
        ''' <value>o[W</value>
        Public Shared ReadOnly Property Version() As String
            Get
                Dim str As String
                Dim ver As Integer
                ver = GetVersion()
                str = String.Format("{0:d}.{1:d}", ver / 100, ver Mod 100)
                Return str
            End Get
        End Property

        ''' <summary>
        ''' G[bZ[WłB
        ''' </summary>
        ''' <remarks>
        ''' G[ɃT[oԂĂG[bZ[WłB
        ''' </remarks>
        ''' <value>G[bZ[W</value>
        Public Shared ReadOnly Property ErrorMessage() As String
            Get
                Dim message As StringBuilder
                message = New StringBuilder(MessageSize)
                GetMessage(MessageError, message, MessageSize)
                Return message.ToString()
            End Get
        End Property

        ''' <summary>
        ''' fobNpłB
        ''' </summary>
        ''' <remarks>
        ''' <see cref="StartDebug"/>ĂяoɃ[̑MsA
        ''' <see cref="EndDebug"/>Ăяoɂ̃vpeBQƂ邱
        ''' ɂăT[oƂ̌M擾邱Ƃł܂B
        ''' </remarks>
        ''' <value>fobNp</value>
        Public Shared ReadOnly Property DebugMessage() As String
            Get
                Dim message As StringBuilder
                message = New StringBuilder(MessageSize)
                GetMessage(MessageDebug, message, MessageSize)
                Return message.ToString()
            End Get
        End Property

        ''' <summary>
        ''' ^CAEglłB
        ''' </summary>
        ''' <remarks>
        ''' ̐ݒl蒷ԃT[o牞ꍇA
        ''' ^CAEgG[ƂďԂ܂B
        ''' Pʂ ms łB
        ''' ڑ̃^CAEg͒ʏ͖łB
        ''' LɂꍇA<see cref="EnableConnectTimeout"/>
        ''' ĂяoĂB
        ''' </remarks>
        ''' <value>^CAEgl</value>
        Public Shared Property Timeout() As Integer
            Get
                Return GetOption(OptionTimeout)
            End Get
            Set(ByVal Value As Integer)
                SetOption(OptionTimeout, Value)
            End Set
        End Property

        ''' <summary>
        ''' wb_obt@TCYłB
        ''' </summary>
        ''' <remarks>
        ''' [MYtt@CWJɃwb_f[^i[
        ''' obt@̃TCYłB
        ''' {I<see cref="Pop3"/>NXŃ[̎MsꍇA
        ''' obt@TCY̐ݒs܂̂ŁÃvpeB
        ''' gpKv͂܂B
        ''' </remarks>
        ''' <value>wb_obt@TCY</value>
        Public Shared Property HeaderMax() As Integer
            Get
                Return GetOption(OptionHeaderMax)
            End Get
            Set(ByVal Value As Integer)
                SetOption(OptionHeaderMax, Value)
            End Set
        End Property

        ''' <summary>
        ''' {obt@TCYłB
        ''' </summary>
        ''' <remarks>
        ''' [MYtt@CWJɃwb_f[^i[
        ''' {̃TCYłB
        ''' {I<see cref="Pop3"/>NXŃ[̎MsꍇA
        ''' [TCYɉobt@TCY̎ws܂̂ŁA
        ''' ̃vpeBgpKv͂܂B
        ''' </remarks>
        ''' <value>{obt@TCY</value>
        Public Shared Property BodyMax() As Integer
            Get
                Return GetOption(OptionBodyMax)
            End Get
            Set(ByVal Value As Integer)
                SetOption(OptionBodyMax, Value)
            End Set
        End Property

        ''' <summary>
        ''' Ytt@Cۑɓt@Cꍇ̏@łB
        ''' </summary>
        ''' <remarks>
        ''' <see cref="FileOverwrite"/>t@C㏑܂B
        ''' <see cref="FileRename"/>t@C̖(gq̑O)ɐǉ܂B
        ''' <see cref="FileAlreadyError"/>t@C쐬G[Ƃ܂B
        ''' </remarks>
        ''' <value>Ytt@Cۑ̓t@C@</value>
        Public Shared Property AlreadyFile() As Integer
            Get
                Return GetOption(OptionAlreadyFile)
            End Get
            Set(ByVal Value As Integer)
                SetOption(OptionAlreadyFile, Value)
            End Set
        End Property

        ''' <summary>
        ''' fobN[h
        ''' </summary>
        ''' <remarks>
        ''' <see cref="DebugStart"/>fobN[hLłB
        ''' <see cref="DebugEnd"/>fobN[hłB
        ''' </remarks>
        ''' <value>fobN[h</value>
        Public Shared Property DebugMode() As Integer
            Get
                Return GetOption(OptionDebugMode)
            End Get
            Set(ByVal Value As Integer)
                SetOption(OptionDebugMode, Value)
            End Set
        End Property

        ''' <summary>
        ''' T[oڑ̃^CAEglłB
        ''' </summary>
        ''' <remarks>
        ''' <see cref="ConnectTimeoutOn"/>ڑ^CAEgLłB
        ''' <see cref="ConnectTimeoutOff"/>ڑ^CAEgłB
        ''' </remarks>
        ''' <value>T[oڑ̃^CAEgl</value>
        Public Shared Property ConnectTimeout() As Integer
            Get
                Return GetOption(OptionConnectTimeout)
            End Get
            Set(ByVal Value As Integer)
                SetOption(OptionConnectTimeout, Value)
            End Set
        End Property

        ''' <summary>
        ''' Ytt@C̋؂蕶łB
        ''' </summary>
        ''' <remarks>
        ''' Ytt@Cꍇ̋؂蕶łB
        '''	ftHgl , łB
        ''' </remarks>
        ''' <value>Ytt@C؂蕶</value>
        Public Shared Property SplitChar() As Char
            Get
                Return Chr(GetOption(OptionSplitChar))
            End Get
            Set(ByVal Value As Char)
                SetOption(OptionSplitChar, Val(Value))
            End Set
        End Property

        ''' <summary>
        ''' M̍ۂɈU߂f[^TCYłB
        ''' </summary>
        ''' <remarks>
        ''' Ytt@CꍇAŎw肵TCỸf[^
        ''' MƁAU߂܂B
        ''' </remarks>
        ''' <value>M̍ۂɈU߂f[^TCY</value>
        Public Shared Property SuspendSize() As Integer
            Get
                Return GetOption(OptionSuspendSize)
            End Get
            Set(ByVal Value As Integer)
                SetOption(OptionSuspendSize, Value)
            End Set
        End Property

        ''' <summary>
        ''' T[o̕ԓ҂̍ۂɓ Sleep() ̎ԂłB
        ''' </summary>
        ''' <value>T[o̕ԓ҂̍ۂɓ Sleep() ̎</value>
        Public Shared Property SleepTime() As Integer
            Get
                Return GetOption(OptionSleepTime)
            End Get
            Set(ByVal Value As Integer)
                SetOption(OptionSleepTime, Value)
            End Set
        End Property

        ''' <summary>
        ''' tB[hobt@̃TCYłB
        ''' </summary>
        ''' <value>tB[hobt@̃TCY</value>
        Public Shared Property FieldMax() As Integer
            Get
                Return GetOption(OptionFieldMax)
            End Get
            Set(ByVal Value As Integer)
                SetOption(OptionFieldMax, Value)
            End Set
        End Property

    End Class
End Namespace

